# class Psych::TreeBuilder

This class works in conjunction with `Psych::Parser` to build an in-memory parse tree that represents a `YAML` document.

## Example¶ ↑

    parser = Psych::Parser.new Psych::TreeBuilder.new
    parser.parse('--- foo')
    tree = parser.handler.root

See `Psych::Handler` for documentation on the event methods used in this class.

### Attributes

root [R]

Returns the root node for the built tree

### Public Class Methods

new ()
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 22
    def initialize
      @stack = []
      @last  = nil
      @root  = nil

      @start_line   = nil
      @start_column = nil
      @end_line     = nil
      @end_column   = nil
    end

Create a new `TreeBuilder` instance

### Public Instance Methods

alias (anchor)
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 103
    def alias anchor
      a = Nodes::Alias.new(anchor)
      set_location(a)
      @last.children << a
      a
    end

end_document (implicit_end = !streaming?)
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 77
    def end_document implicit_end = !streaming?
      @last.implicit_end = implicit_end
      n = pop
      set_end_location(n)
      n
    end

Handles `end_document` events with `version`, `tag_directives`, and `implicit` styling.

See `Psych::Handler#start_document`

end_stream ()
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 90
    def end_stream
      n = pop
      set_end_location(n)
      n
    end

event_location (start_line, start_column, end_line, end_column)
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 33
    def event_location(start_line, start_column, end_line, end_column)
      @start_line   = start_line
      @start_column = start_column
      @end_line     = end_line
      @end_column   = end_column
    end

scalar (value, anchor, tag, plain, quoted, style)
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 96
    def scalar value, anchor, tag, plain, quoted, style
      s = Nodes::Scalar.new(value,anchor,tag,plain,quoted,style)
      set_location(s)
      @last.children << s
      s
    end

start_document (version, tag_directives, implicit)
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 65
    def start_document version, tag_directives, implicit
      n = Nodes::Document.new version, tag_directives, implicit
      set_start_location(n)
      @last.children << n
      push n
    end

Handles `start_document` events with `version`, `tag_directives`, and `implicit` styling.

See `Psych::Handler#start_document`

start_stream (encoding)
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 84
    def start_stream encoding
      @root = Nodes::Stream.new(encoding)
      set_start_location(@root)
      push @root
    end

### Private Instance Methods

pop ()
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 116
    def pop
      x = @stack.pop
      @last = @stack.last
      x
    end

push (value)
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 111
    def push value
      @stack.push value
      @last = value
    end

set_end_location (node)
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 132
    def set_end_location(node)
      node.end_line   = @end_line
      node.end_column = @end_column
    end

set_location (node)
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 122
    def set_location(node)
      set_start_location(node)
      set_end_location(node)
    end

set_start_location (node)
Source

    # File ext/psych/lib/psych/tree_builder.rb, line 127
    def set_start_location(node)
      node.start_line   = @start_line
      node.start_column = @start_column
    end